<?php

defined('MOODLE_INTERNAL') || die();

if ($ADMIN->fulltree) {

    $settings = new theme_boost_admin_settingspage_tabs('themesettingcisco3', get_string('configtitle', 'theme_cisco3'));

    $page = new admin_settingpage('theme_cisco3_general', get_string('generalsettings', 'theme_cisco3'));

    $setting = new admin_setting_configtextarea(
        'theme_cisco3/scsspre',
        get_string('rawscsspre', 'theme_cisco3'),
        get_string('rawscsspre_desc', 'theme_cisco3'),
        '',
        PARAM_RAW
    );
    $setting->set_updatedcallback('theme_reset_all_caches');
    $page->add($setting);

    $setting = new admin_setting_configtextarea(
        'theme_cisco3/scss',
        get_string('rawscss', 'theme_cisco3'),
        get_string('rawscss_desc', 'theme_cisco3'),
        '',
        PARAM_RAW
    );
    $setting->set_updatedcallback('theme_reset_all_caches');
    $page->add($setting);

    $settings->add($page);
}
